"""m"""
import os
import xdg
import xdg.BaseDirectory
import xdg.DesktopEntry

import rox

def makeAppdirEntry(path):
	def is0launch(path):
		launchcmd = None
		f = open(os.path.join(path,'AppRun'))
		for line in f:
			line = line.strip()
			if line.find(' 0launch ') != -1:
				start = line.find(' 0launch ')
				end = line.rfind('"$@"')
				launchcmd = line[start:end].strip()
		return launchcmd
	is0launch(path)
	appname = os.path.basename(path)
	execstr = is0launch(path)
	if execstr is None:
		execstr = os.path.join(path, 'AppRun')
	dpath = os.path.join(rox.basedir.load_first_config('autostart'),'%s.desktop' % appname)
	iconpath = os.path.join(path, '.DirIcon')
	dentry = xdg.DesktopEntry.DesktopEntry(dpath)
	dentry.addGroup('Desktop Entry')
	dentry.set('Type', 'Application')
	dentry.set('Name', appname)
	dentry.set('Exec', execstr)
	dentry.set('Icon', iconpath)
	return dentry

def makeExecutableEntry(path):
	appname = os.path.basename(path)
	execstr = os.path.join(path, 'AppRun')
	dpath = os.path.join(rox.basedir.load_first_config('autostart'),'%s.desktop' % appname)
	dentry = xdg.DesktopEntry.DesktopEntry(dpath)
	dentry.addGroup('Desktop Entry')
	dentry.set('Type', 'Application')
	dentry.set('Name', appname)
	dentry.set('Exec', execstr)
	return dentry


def findParentEntry(entry):
	entryfilename = os.path.basename(entry.getFileName())
	for dir in xdg.BaseDirectory.load_config_paths('autostart'):
		if dir == xdg.BaseDirectory.load_first_config('autostart'):
			continue
		else:
			ppath = os.path.join(dir, entryfilename)
			if os.path.exists(ppath):
				return xdg.DesktopEntry.DesktopEntry(ppath)
